import type { Emitter } from '../types';
declare type TaskInstruction = string;
declare type TaskEvent = {
    readonly taskName: string;
    readonly instruction: string;
};
declare type ScheduleConfigurationInput = {
    readonly activeTaskInstructions: TaskInstruction[];
    readonly limit: number;
};
declare type Schedule = (configuration: ScheduleConfigurationInput) => Promise<TaskInstruction[]>;
declare type Delay = (attemptNumber: number) => number;
declare type TaskInput = {
    readonly concurrency?: number;
    readonly exclusive?: boolean;
    readonly delay?: Delay;
    readonly name: string;
    readonly schedule: Schedule;
};
declare type PlantonConfigurationInput = {
    readonly getActiveTaskInstructions: (taskName: string) => TaskInstruction[];
    readonly tasks: TaskInput[];
};
declare type EventMap = {
    task: TaskEvent;
};
declare type Planton = {
    events: Emitter<EventMap>;
    terminate: () => Promise<void>;
};
declare const createPlanton: (configuration: PlantonConfigurationInput) => Planton;
export { createPlanton, };
