export declare type EventMap = Record<string, any>;
declare type EventKey<T extends EventMap> = string & keyof T;
declare type EventReceiver<T> = (parameters: T) => void;
export declare type Emitter<T extends EventMap> = {
    on<K extends EventKey<T>>(eventName: K, function_: EventReceiver<T[K]>): void;
    off<K extends EventKey<T>>(eventName: K, function_: EventReceiver<T[K]>): void;
    emit<K extends EventKey<T>>(eventName: K, parameters: T[K]): void;
};
export {};
